// DictFinderDlg.cpp : implementation file
//

#include "stdafx.h"
#include "DictFinder.h"
#include "DictFinderDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDictFinderDlg dialog

CDictFinderDlg::CDictFinderDlg(CWnd* pParent /*=NULL*/)
    : CDialog(CDictFinderDlg::IDD, pParent)
{
    //{{AFX_DATA_INIT(CDictFinderDlg)
    m_inputText = _T("");
    m_resultWord = _T("");
    //}}AFX_DATA_INIT
    // Note that LoadIcon does not require a subsequent DestroyIcon in Win32
    m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CDictFinderDlg::DoDataExchange(CDataExchange* pDX)
{
    CDialog::DoDataExchange(pDX);
    //{{AFX_DATA_MAP(CDictFinderDlg)
    DDX_Text(pDX, IDC_INPUT_WORD, m_inputText);
    DDX_Text(pDX, IDC_RESULT_WORD, m_resultWord);
    //}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDictFinderDlg, CDialog)
    //{{AFX_MSG_MAP(CDictFinderDlg)
    ON_WM_PAINT()
    ON_WM_QUERYDRAGICON()
    ON_EN_CHANGE(IDC_INPUT_WORD, OnChangeInputWord)
    //}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDictFinderDlg message handlers

FILE *fp_key = NULL;
char keywordfile[256] = "dict_key.txt";
size_t result;

#define MMC_BLOCK_SIZE			512
#define DATA_BLOCK_SIZE			64
#define SHIFTER_DATA_BLOCK		6


char buffer[DATA_BLOCK_SIZE];

int file_len = 0;

int begin_find = 0;
size_t first = 0; /* Ia?aue yeaiaio a ianneaa */
size_t last = 0;
char idx_char = 0;

#define KEY_WORD_FILE_LEN	3661840
char MMC[KEY_WORD_FILE_LEN];


BOOL CDictFinderDlg::OnInitDialog()
{
    CDialog::OnInitDialog();

    // Set the icon for this dialog.  The framework does this automatically
    //  when the application's main window is not a dialog
    SetIcon(m_hIcon, TRUE);            // Set big icon
    SetIcon(m_hIcon, FALSE);        // Set small icon
    
    // TODO: Add extra initialization here

    fp_key = fopen(keywordfile,"r");
    if (fp_key==NULL) 
    {
        AfxMessageBox( _T("File error") );
        exit (1);
    }

    fseek (fp_key, 0 , SEEK_END );
    file_len = ftell(fp_key);
    last = file_len / DATA_BLOCK_SIZE;  /* Yeaiaio a ianneaa, NEAAO?UEE CA iineaaiei */
    begin_find = 0;
    idx_char = 0;

    fseek (fp_key, 0 , SEEK_SET );    
	result = fread (MMC, 1, KEY_WORD_FILE_LEN, fp_key);
    fseek (fp_key, 0 , SEEK_SET );


    return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CDictFinderDlg::OnPaint() 
{
    if (IsIconic())
    {
        CPaintDC dc(this); // device context for painting

        SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

        // Center icon in client rectangle
        int cxIcon = GetSystemMetrics(SM_CXICON);
        int cyIcon = GetSystemMetrics(SM_CYICON);
        CRect rect;
        GetClientRect(&rect);
        int x = (rect.Width() - cxIcon + 1) / 2;
        int y = (rect.Height() - cyIcon + 1) / 2;

        // Draw the icon
        dc.DrawIcon(x, y, m_hIcon);
    }
    else
    {
        CDialog::OnPaint();
    }
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CDictFinderDlg::OnQueryDragIcon()
{
    return (HCURSOR) m_hIcon;
}



unsigned char read_block (char* buff, unsigned long int addr)
{ 
  unsigned char temp, buff_idx;
  unsigned long int count;
  unsigned short int in_block_offs, j; 

  unsigned char a1 = addr >> 24;
  unsigned char a2 = addr >> 16;
  unsigned char a3 = addr >> 8;
  addr &= 0xffffff00;

  //temp=sd_cmd (0x51,a1,a2,a3,0x0,0x95);		//Send CMD17

  in_block_offs = addr % MMC_BLOCK_SIZE;
 
  for(j=0, buff_idx=0; j<MMC_BLOCK_SIZE; j++)
	{
		if( in_block_offs <= j && (in_block_offs + DATA_BLOCK_SIZE) > j )
		{
			buff[buff_idx] = MMC[addr+buff_idx];//spi_receive();
			buff_idx++;
		}
		else
			;//spi_receive();
	}

 return 0;
}


#define FIND_FIRST_POSITION		1
#define FIND_LAST_POSITION		2


int find_last(int idx, char ch, char flg_position){
	
	// AfxMessageBox( CString(ch + len-1) );
	char buffer[DATA_BLOCK_SIZE];
	
	unsigned char a;
	unsigned char x = ch;
	unsigned long int mid;

	while ( first < last ) {
		mid = ( first + last ) >> 1;
		
		//fseek (fp_key, (mid * KEY_STR_LEN) + idx, SEEK_SET );
		//result = fread (&a, 1, 1, fp_key);

//		int tt1 = mid * DATA_BLOCK_SIZE;
//		int tt2 = mid << 6;


		read_block(buffer, (mid << SHIFTER_DATA_BLOCK));
		a = buffer[idx];
		
		switch( flg_position )
		{
		case FIND_FIRST_POSITION:
            if ( x <= a ) {        
                last = mid;
            } else {
                first = mid + 1;
            }
			break;
		case FIND_LAST_POSITION:
            if ( x < a ) {
                last = mid;
            } else {
                first = mid + 1;
            }
			break;
		}
	}
	
	return last;
}


#define SEARCH_STR_LEN	7

#define FIRST_POS	0
#define LAST_POS	1
int first_last_position[2][SEARCH_STR_LEN];		// !!! realy 6

char last_founded_idx = 0;

void CDictFinderDlg::OnChangeInputWord() 
{
    // TODO: If this is a RICHEDIT control, the control will not
    // send this notification unless you override the CDialog::OnInitDialog()
    // function and call CRichEditCtrl().SetEventMask()
    // with the ENM_CHANGE flag ORed into the mask.
	int i=0;
    UpdateData(TRUE);
    
	first_last_position[FIRST_POS][0] = 0;
	first_last_position[LAST_POS][0] = file_len / DATA_BLOCK_SIZE;
    
    memset (buffer, '|', DATA_BLOCK_SIZE);
	
    first = begin_find;
	
    char *ch = m_inputText.GetBuffer(strlen(m_inputText));
	char a;
    int len = strlen(ch);
    if ( len > 0 && len < SEARCH_STR_LEN )
    {
		if( (last_founded_idx+1) < (len - 1) )
			idx_char = last_founded_idx;
		else
			idx_char = len - 1;

		a = ch[idx_char];
		
		first = first_last_position[FIRST_POS][idx_char];
		first_last_position[FIRST_POS][idx_char+1] = find_last(idx_char, a, FIND_FIRST_POSITION);
		
		last = first_last_position[LAST_POS][idx_char];
		first_last_position[LAST_POS][idx_char+1] = find_last(idx_char, a, FIND_LAST_POSITION);
		
  		read_block(buffer, (first_last_position[FIRST_POS][idx_char+1] << SHIFTER_DATA_BLOCK));
		if ( buffer[idx_char] == a )
			last_founded_idx = idx_char;
		else
	  		read_block(buffer, (first_last_position[FIRST_POS][idx_char] << SHIFTER_DATA_BLOCK));

	}
	else
	{
		buffer[0] = 0;		
	}
	
	m_resultWord = buffer;
	UpdateData(FALSE);
	
}
